import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchDeleteBuildsInput, BatchDeleteBuildsOutput } from "../models/models_0";
import { deserializeAws_json1_1BatchDeleteBuildsCommand, serializeAws_json1_1BatchDeleteBuildsCommand, } from "../protocols/Aws_json1_1";
var BatchDeleteBuildsCommand = (function (_super) {
    __extends(BatchDeleteBuildsCommand, _super);
    function BatchDeleteBuildsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchDeleteBuildsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "BatchDeleteBuildsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchDeleteBuildsInput.filterSensitiveLog,
            outputFilterSensitiveLog: BatchDeleteBuildsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchDeleteBuildsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1BatchDeleteBuildsCommand(input, context);
    };
    BatchDeleteBuildsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1BatchDeleteBuildsCommand(output, context);
    };
    return BatchDeleteBuildsCommand;
}($Command));
export { BatchDeleteBuildsCommand };
