import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchGetBuildBatchesInput, BatchGetBuildBatchesOutput } from "../models/models_0";
import { deserializeAws_json1_1BatchGetBuildBatchesCommand, serializeAws_json1_1BatchGetBuildBatchesCommand, } from "../protocols/Aws_json1_1";
var BatchGetBuildBatchesCommand = (function (_super) {
    __extends(BatchGetBuildBatchesCommand, _super);
    function BatchGetBuildBatchesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchGetBuildBatchesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "BatchGetBuildBatchesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchGetBuildBatchesInput.filterSensitiveLog,
            outputFilterSensitiveLog: BatchGetBuildBatchesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchGetBuildBatchesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1BatchGetBuildBatchesCommand(input, context);
    };
    BatchGetBuildBatchesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1BatchGetBuildBatchesCommand(output, context);
    };
    return BatchGetBuildBatchesCommand;
}($Command));
export { BatchGetBuildBatchesCommand };
