import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateWebhookInput, CreateWebhookOutput } from "../models/models_0";
import { deserializeAws_json1_1CreateWebhookCommand, serializeAws_json1_1CreateWebhookCommand, } from "../protocols/Aws_json1_1";
var CreateWebhookCommand = (function (_super) {
    __extends(CreateWebhookCommand, _super);
    function CreateWebhookCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateWebhookCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "CreateWebhookCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateWebhookInput.filterSensitiveLog,
            outputFilterSensitiveLog: CreateWebhookOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateWebhookCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1CreateWebhookCommand(input, context);
    };
    CreateWebhookCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1CreateWebhookCommand(output, context);
    };
    return CreateWebhookCommand;
}($Command));
export { CreateWebhookCommand };
