import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteBuildBatchInput, DeleteBuildBatchOutput } from "../models/models_0";
import { deserializeAws_json1_1DeleteBuildBatchCommand, serializeAws_json1_1DeleteBuildBatchCommand, } from "../protocols/Aws_json1_1";
var DeleteBuildBatchCommand = (function (_super) {
    __extends(DeleteBuildBatchCommand, _super);
    function DeleteBuildBatchCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteBuildBatchCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "DeleteBuildBatchCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteBuildBatchInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteBuildBatchOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteBuildBatchCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DeleteBuildBatchCommand(input, context);
    };
    DeleteBuildBatchCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DeleteBuildBatchCommand(output, context);
    };
    return DeleteBuildBatchCommand;
}($Command));
export { DeleteBuildBatchCommand };
