import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteReportInput, DeleteReportOutput } from "../models/models_0";
import { deserializeAws_json1_1DeleteReportCommand, serializeAws_json1_1DeleteReportCommand, } from "../protocols/Aws_json1_1";
var DeleteReportCommand = (function (_super) {
    __extends(DeleteReportCommand, _super);
    function DeleteReportCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteReportCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "DeleteReportCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteReportInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteReportOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteReportCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DeleteReportCommand(input, context);
    };
    DeleteReportCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DeleteReportCommand(output, context);
    };
    return DeleteReportCommand;
}($Command));
export { DeleteReportCommand };
