import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteReportGroupInput, DeleteReportGroupOutput } from "../models/models_0";
import { deserializeAws_json1_1DeleteReportGroupCommand, serializeAws_json1_1DeleteReportGroupCommand, } from "../protocols/Aws_json1_1";
var DeleteReportGroupCommand = (function (_super) {
    __extends(DeleteReportGroupCommand, _super);
    function DeleteReportGroupCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteReportGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "DeleteReportGroupCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteReportGroupInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteReportGroupOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteReportGroupCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DeleteReportGroupCommand(input, context);
    };
    DeleteReportGroupCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DeleteReportGroupCommand(output, context);
    };
    return DeleteReportGroupCommand;
}($Command));
export { DeleteReportGroupCommand };
