import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteSourceCredentialsInput, DeleteSourceCredentialsOutput } from "../models/models_0";
import { deserializeAws_json1_1DeleteSourceCredentialsCommand, serializeAws_json1_1DeleteSourceCredentialsCommand, } from "../protocols/Aws_json1_1";
var DeleteSourceCredentialsCommand = (function (_super) {
    __extends(DeleteSourceCredentialsCommand, _super);
    function DeleteSourceCredentialsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteSourceCredentialsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "DeleteSourceCredentialsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteSourceCredentialsInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteSourceCredentialsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteSourceCredentialsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DeleteSourceCredentialsCommand(input, context);
    };
    DeleteSourceCredentialsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DeleteSourceCredentialsCommand(output, context);
    };
    return DeleteSourceCredentialsCommand;
}($Command));
export { DeleteSourceCredentialsCommand };
