import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeTestCasesInput, DescribeTestCasesOutput } from "../models/models_0";
import { deserializeAws_json1_1DescribeTestCasesCommand, serializeAws_json1_1DescribeTestCasesCommand, } from "../protocols/Aws_json1_1";
var DescribeTestCasesCommand = (function (_super) {
    __extends(DescribeTestCasesCommand, _super);
    function DescribeTestCasesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeTestCasesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "DescribeTestCasesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeTestCasesInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeTestCasesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeTestCasesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DescribeTestCasesCommand(input, context);
    };
    DescribeTestCasesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DescribeTestCasesCommand(output, context);
    };
    return DescribeTestCasesCommand;
}($Command));
export { DescribeTestCasesCommand };
