import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetReportGroupTrendInput, GetReportGroupTrendOutput } from "../models/models_0";
import { deserializeAws_json1_1GetReportGroupTrendCommand, serializeAws_json1_1GetReportGroupTrendCommand, } from "../protocols/Aws_json1_1";
var GetReportGroupTrendCommand = (function (_super) {
    __extends(GetReportGroupTrendCommand, _super);
    function GetReportGroupTrendCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetReportGroupTrendCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "GetReportGroupTrendCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetReportGroupTrendInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetReportGroupTrendOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetReportGroupTrendCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetReportGroupTrendCommand(input, context);
    };
    GetReportGroupTrendCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetReportGroupTrendCommand(output, context);
    };
    return GetReportGroupTrendCommand;
}($Command));
export { GetReportGroupTrendCommand };
