import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { InvalidateProjectCacheInput, InvalidateProjectCacheOutput } from "../models/models_0";
import { deserializeAws_json1_1InvalidateProjectCacheCommand, serializeAws_json1_1InvalidateProjectCacheCommand, } from "../protocols/Aws_json1_1";
var InvalidateProjectCacheCommand = (function (_super) {
    __extends(InvalidateProjectCacheCommand, _super);
    function InvalidateProjectCacheCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    InvalidateProjectCacheCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "InvalidateProjectCacheCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: InvalidateProjectCacheInput.filterSensitiveLog,
            outputFilterSensitiveLog: InvalidateProjectCacheOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    InvalidateProjectCacheCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1InvalidateProjectCacheCommand(input, context);
    };
    InvalidateProjectCacheCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1InvalidateProjectCacheCommand(output, context);
    };
    return InvalidateProjectCacheCommand;
}($Command));
export { InvalidateProjectCacheCommand };
