import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListBuildBatchesInput, ListBuildBatchesOutput } from "../models/models_0";
import { deserializeAws_json1_1ListBuildBatchesCommand, serializeAws_json1_1ListBuildBatchesCommand, } from "../protocols/Aws_json1_1";
var ListBuildBatchesCommand = (function (_super) {
    __extends(ListBuildBatchesCommand, _super);
    function ListBuildBatchesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListBuildBatchesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListBuildBatchesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListBuildBatchesInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListBuildBatchesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListBuildBatchesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListBuildBatchesCommand(input, context);
    };
    ListBuildBatchesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListBuildBatchesCommand(output, context);
    };
    return ListBuildBatchesCommand;
}($Command));
export { ListBuildBatchesCommand };
