import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListBuildBatchesForProjectInput, ListBuildBatchesForProjectOutput } from "../models/models_0";
import { deserializeAws_json1_1ListBuildBatchesForProjectCommand, serializeAws_json1_1ListBuildBatchesForProjectCommand, } from "../protocols/Aws_json1_1";
var ListBuildBatchesForProjectCommand = (function (_super) {
    __extends(ListBuildBatchesForProjectCommand, _super);
    function ListBuildBatchesForProjectCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListBuildBatchesForProjectCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListBuildBatchesForProjectCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListBuildBatchesForProjectInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListBuildBatchesForProjectOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListBuildBatchesForProjectCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListBuildBatchesForProjectCommand(input, context);
    };
    ListBuildBatchesForProjectCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListBuildBatchesForProjectCommand(output, context);
    };
    return ListBuildBatchesForProjectCommand;
}($Command));
export { ListBuildBatchesForProjectCommand };
