import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListCuratedEnvironmentImagesInput, ListCuratedEnvironmentImagesOutput } from "../models/models_0";
import { deserializeAws_json1_1ListCuratedEnvironmentImagesCommand, serializeAws_json1_1ListCuratedEnvironmentImagesCommand, } from "../protocols/Aws_json1_1";
var ListCuratedEnvironmentImagesCommand = (function (_super) {
    __extends(ListCuratedEnvironmentImagesCommand, _super);
    function ListCuratedEnvironmentImagesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListCuratedEnvironmentImagesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListCuratedEnvironmentImagesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListCuratedEnvironmentImagesInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListCuratedEnvironmentImagesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListCuratedEnvironmentImagesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListCuratedEnvironmentImagesCommand(input, context);
    };
    ListCuratedEnvironmentImagesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListCuratedEnvironmentImagesCommand(output, context);
    };
    return ListCuratedEnvironmentImagesCommand;
}($Command));
export { ListCuratedEnvironmentImagesCommand };
