import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListReportsForReportGroupInput, ListReportsForReportGroupOutput } from "../models/models_0";
import { deserializeAws_json1_1ListReportsForReportGroupCommand, serializeAws_json1_1ListReportsForReportGroupCommand, } from "../protocols/Aws_json1_1";
var ListReportsForReportGroupCommand = (function (_super) {
    __extends(ListReportsForReportGroupCommand, _super);
    function ListReportsForReportGroupCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListReportsForReportGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListReportsForReportGroupCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListReportsForReportGroupInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListReportsForReportGroupOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListReportsForReportGroupCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListReportsForReportGroupCommand(input, context);
    };
    ListReportsForReportGroupCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListReportsForReportGroupCommand(output, context);
    };
    return ListReportsForReportGroupCommand;
}($Command));
export { ListReportsForReportGroupCommand };
