import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListSharedProjectsInput, ListSharedProjectsOutput } from "../models/models_0";
import { deserializeAws_json1_1ListSharedProjectsCommand, serializeAws_json1_1ListSharedProjectsCommand, } from "../protocols/Aws_json1_1";
var ListSharedProjectsCommand = (function (_super) {
    __extends(ListSharedProjectsCommand, _super);
    function ListSharedProjectsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListSharedProjectsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListSharedProjectsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListSharedProjectsInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListSharedProjectsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListSharedProjectsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListSharedProjectsCommand(input, context);
    };
    ListSharedProjectsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListSharedProjectsCommand(output, context);
    };
    return ListSharedProjectsCommand;
}($Command));
export { ListSharedProjectsCommand };
