import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListSourceCredentialsInput, ListSourceCredentialsOutput } from "../models/models_0";
import { deserializeAws_json1_1ListSourceCredentialsCommand, serializeAws_json1_1ListSourceCredentialsCommand, } from "../protocols/Aws_json1_1";
var ListSourceCredentialsCommand = (function (_super) {
    __extends(ListSourceCredentialsCommand, _super);
    function ListSourceCredentialsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListSourceCredentialsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "ListSourceCredentialsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListSourceCredentialsInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListSourceCredentialsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListSourceCredentialsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListSourceCredentialsCommand(input, context);
    };
    ListSourceCredentialsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListSourceCredentialsCommand(output, context);
    };
    return ListSourceCredentialsCommand;
}($Command));
export { ListSourceCredentialsCommand };
