import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RetryBuildInput, RetryBuildOutput } from "../models/models_0";
import { deserializeAws_json1_1RetryBuildCommand, serializeAws_json1_1RetryBuildCommand, } from "../protocols/Aws_json1_1";
var RetryBuildCommand = (function (_super) {
    __extends(RetryBuildCommand, _super);
    function RetryBuildCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RetryBuildCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "RetryBuildCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RetryBuildInput.filterSensitiveLog,
            outputFilterSensitiveLog: RetryBuildOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RetryBuildCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1RetryBuildCommand(input, context);
    };
    RetryBuildCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1RetryBuildCommand(output, context);
    };
    return RetryBuildCommand;
}($Command));
export { RetryBuildCommand };
