import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { StartBuildBatchInput, StartBuildBatchOutput } from "../models/models_0";
import { deserializeAws_json1_1StartBuildBatchCommand, serializeAws_json1_1StartBuildBatchCommand, } from "../protocols/Aws_json1_1";
var StartBuildBatchCommand = (function (_super) {
    __extends(StartBuildBatchCommand, _super);
    function StartBuildBatchCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    StartBuildBatchCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "StartBuildBatchCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: StartBuildBatchInput.filterSensitiveLog,
            outputFilterSensitiveLog: StartBuildBatchOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    StartBuildBatchCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1StartBuildBatchCommand(input, context);
    };
    StartBuildBatchCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1StartBuildBatchCommand(output, context);
    };
    return StartBuildBatchCommand;
}($Command));
export { StartBuildBatchCommand };
