import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { StopBuildBatchInput, StopBuildBatchOutput } from "../models/models_0";
import { deserializeAws_json1_1StopBuildBatchCommand, serializeAws_json1_1StopBuildBatchCommand, } from "../protocols/Aws_json1_1";
var StopBuildBatchCommand = (function (_super) {
    __extends(StopBuildBatchCommand, _super);
    function StopBuildBatchCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    StopBuildBatchCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "StopBuildBatchCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: StopBuildBatchInput.filterSensitiveLog,
            outputFilterSensitiveLog: StopBuildBatchOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    StopBuildBatchCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1StopBuildBatchCommand(input, context);
    };
    StopBuildBatchCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1StopBuildBatchCommand(output, context);
    };
    return StopBuildBatchCommand;
}($Command));
export { StopBuildBatchCommand };
