import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { StopBuildInput, StopBuildOutput } from "../models/models_0";
import { deserializeAws_json1_1StopBuildCommand, serializeAws_json1_1StopBuildCommand } from "../protocols/Aws_json1_1";
var StopBuildCommand = (function (_super) {
    __extends(StopBuildCommand, _super);
    function StopBuildCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    StopBuildCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "StopBuildCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: StopBuildInput.filterSensitiveLog,
            outputFilterSensitiveLog: StopBuildOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    StopBuildCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1StopBuildCommand(input, context);
    };
    StopBuildCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1StopBuildCommand(output, context);
    };
    return StopBuildCommand;
}($Command));
export { StopBuildCommand };
