import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateProjectVisibilityInput, UpdateProjectVisibilityOutput } from "../models/models_0";
import { deserializeAws_json1_1UpdateProjectVisibilityCommand, serializeAws_json1_1UpdateProjectVisibilityCommand, } from "../protocols/Aws_json1_1";
var UpdateProjectVisibilityCommand = (function (_super) {
    __extends(UpdateProjectVisibilityCommand, _super);
    function UpdateProjectVisibilityCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateProjectVisibilityCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "UpdateProjectVisibilityCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateProjectVisibilityInput.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateProjectVisibilityOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateProjectVisibilityCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1UpdateProjectVisibilityCommand(input, context);
    };
    UpdateProjectVisibilityCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1UpdateProjectVisibilityCommand(output, context);
    };
    return UpdateProjectVisibilityCommand;
}($Command));
export { UpdateProjectVisibilityCommand };
