import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateReportGroupInput, UpdateReportGroupOutput } from "../models/models_0";
import { deserializeAws_json1_1UpdateReportGroupCommand, serializeAws_json1_1UpdateReportGroupCommand, } from "../protocols/Aws_json1_1";
var UpdateReportGroupCommand = (function (_super) {
    __extends(UpdateReportGroupCommand, _super);
    function UpdateReportGroupCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateReportGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "UpdateReportGroupCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateReportGroupInput.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateReportGroupOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateReportGroupCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1UpdateReportGroupCommand(input, context);
    };
    UpdateReportGroupCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1UpdateReportGroupCommand(output, context);
    };
    return UpdateReportGroupCommand;
}($Command));
export { UpdateReportGroupCommand };
