import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateWebhookInput, UpdateWebhookOutput } from "../models/models_0";
import { deserializeAws_json1_1UpdateWebhookCommand, serializeAws_json1_1UpdateWebhookCommand, } from "../protocols/Aws_json1_1";
var UpdateWebhookCommand = (function (_super) {
    __extends(UpdateWebhookCommand, _super);
    function UpdateWebhookCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateWebhookCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodeBuildClient";
        var commandName = "UpdateWebhookCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateWebhookInput.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateWebhookOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateWebhookCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1UpdateWebhookCommand(input, context);
    };
    UpdateWebhookCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1UpdateWebhookCommand(output, context);
    };
    return UpdateWebhookCommand;
}($Command));
export { UpdateWebhookCommand };
