import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AcknowledgeThirdPartyJobInput, AcknowledgeThirdPartyJobOutput } from "../models/models_0";
import { deserializeAws_json1_1AcknowledgeThirdPartyJobCommand, serializeAws_json1_1AcknowledgeThirdPartyJobCommand, } from "../protocols/Aws_json1_1";
var AcknowledgeThirdPartyJobCommand = (function (_super) {
    __extends(AcknowledgeThirdPartyJobCommand, _super);
    function AcknowledgeThirdPartyJobCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AcknowledgeThirdPartyJobCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "AcknowledgeThirdPartyJobCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AcknowledgeThirdPartyJobInput.filterSensitiveLog,
            outputFilterSensitiveLog: AcknowledgeThirdPartyJobOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AcknowledgeThirdPartyJobCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1AcknowledgeThirdPartyJobCommand(input, context);
    };
    AcknowledgeThirdPartyJobCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1AcknowledgeThirdPartyJobCommand(output, context);
    };
    return AcknowledgeThirdPartyJobCommand;
}($Command));
export { AcknowledgeThirdPartyJobCommand };
