import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteCustomActionTypeInput } from "../models/models_0";
import { deserializeAws_json1_1DeleteCustomActionTypeCommand, serializeAws_json1_1DeleteCustomActionTypeCommand, } from "../protocols/Aws_json1_1";
var DeleteCustomActionTypeCommand = (function (_super) {
    __extends(DeleteCustomActionTypeCommand, _super);
    function DeleteCustomActionTypeCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteCustomActionTypeCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "DeleteCustomActionTypeCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteCustomActionTypeInput.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteCustomActionTypeCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1DeleteCustomActionTypeCommand(input, context);
    };
    DeleteCustomActionTypeCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1DeleteCustomActionTypeCommand(output, context);
    };
    return DeleteCustomActionTypeCommand;
}($Command));
export { DeleteCustomActionTypeCommand };
