import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetActionTypeInput, GetActionTypeOutput } from "../models/models_0";
import { deserializeAws_json1_1GetActionTypeCommand, serializeAws_json1_1GetActionTypeCommand, } from "../protocols/Aws_json1_1";
var GetActionTypeCommand = (function (_super) {
    __extends(GetActionTypeCommand, _super);
    function GetActionTypeCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetActionTypeCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "GetActionTypeCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetActionTypeInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetActionTypeOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetActionTypeCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetActionTypeCommand(input, context);
    };
    GetActionTypeCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetActionTypeCommand(output, context);
    };
    return GetActionTypeCommand;
}($Command));
export { GetActionTypeCommand };
