import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetJobDetailsInput, GetJobDetailsOutput } from "../models/models_0";
import { deserializeAws_json1_1GetJobDetailsCommand, serializeAws_json1_1GetJobDetailsCommand, } from "../protocols/Aws_json1_1";
var GetJobDetailsCommand = (function (_super) {
    __extends(GetJobDetailsCommand, _super);
    function GetJobDetailsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetJobDetailsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "GetJobDetailsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetJobDetailsInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetJobDetailsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetJobDetailsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetJobDetailsCommand(input, context);
    };
    GetJobDetailsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetJobDetailsCommand(output, context);
    };
    return GetJobDetailsCommand;
}($Command));
export { GetJobDetailsCommand };
