import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetPipelineStateInput, GetPipelineStateOutput } from "../models/models_0";
import { deserializeAws_json1_1GetPipelineStateCommand, serializeAws_json1_1GetPipelineStateCommand, } from "../protocols/Aws_json1_1";
var GetPipelineStateCommand = (function (_super) {
    __extends(GetPipelineStateCommand, _super);
    function GetPipelineStateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetPipelineStateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "GetPipelineStateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetPipelineStateInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetPipelineStateOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetPipelineStateCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1GetPipelineStateCommand(input, context);
    };
    GetPipelineStateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1GetPipelineStateCommand(output, context);
    };
    return GetPipelineStateCommand;
}($Command));
export { GetPipelineStateCommand };
