import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListWebhooksInput, ListWebhooksOutput } from "../models/models_0";
import { deserializeAws_json1_1ListWebhooksCommand, serializeAws_json1_1ListWebhooksCommand, } from "../protocols/Aws_json1_1";
var ListWebhooksCommand = (function (_super) {
    __extends(ListWebhooksCommand, _super);
    function ListWebhooksCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListWebhooksCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "ListWebhooksCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListWebhooksInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListWebhooksOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListWebhooksCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListWebhooksCommand(input, context);
    };
    ListWebhooksCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListWebhooksCommand(output, context);
    };
    return ListWebhooksCommand;
}($Command));
export { ListWebhooksCommand };
