import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PollForThirdPartyJobsInput, PollForThirdPartyJobsOutput } from "../models/models_0";
import { deserializeAws_json1_1PollForThirdPartyJobsCommand, serializeAws_json1_1PollForThirdPartyJobsCommand, } from "../protocols/Aws_json1_1";
var PollForThirdPartyJobsCommand = (function (_super) {
    __extends(PollForThirdPartyJobsCommand, _super);
    function PollForThirdPartyJobsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PollForThirdPartyJobsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "PollForThirdPartyJobsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PollForThirdPartyJobsInput.filterSensitiveLog,
            outputFilterSensitiveLog: PollForThirdPartyJobsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PollForThirdPartyJobsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1PollForThirdPartyJobsCommand(input, context);
    };
    PollForThirdPartyJobsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1PollForThirdPartyJobsCommand(output, context);
    };
    return PollForThirdPartyJobsCommand;
}($Command));
export { PollForThirdPartyJobsCommand };
