import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutActionRevisionInput, PutActionRevisionOutput } from "../models/models_0";
import { deserializeAws_json1_1PutActionRevisionCommand, serializeAws_json1_1PutActionRevisionCommand, } from "../protocols/Aws_json1_1";
var PutActionRevisionCommand = (function (_super) {
    __extends(PutActionRevisionCommand, _super);
    function PutActionRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutActionRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "PutActionRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutActionRevisionInput.filterSensitiveLog,
            outputFilterSensitiveLog: PutActionRevisionOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutActionRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1PutActionRevisionCommand(input, context);
    };
    PutActionRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1PutActionRevisionCommand(output, context);
    };
    return PutActionRevisionCommand;
}($Command));
export { PutActionRevisionCommand };
