import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutThirdPartyJobSuccessResultInput } from "../models/models_0";
import { deserializeAws_json1_1PutThirdPartyJobSuccessResultCommand, serializeAws_json1_1PutThirdPartyJobSuccessResultCommand, } from "../protocols/Aws_json1_1";
var PutThirdPartyJobSuccessResultCommand = (function (_super) {
    __extends(PutThirdPartyJobSuccessResultCommand, _super);
    function PutThirdPartyJobSuccessResultCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutThirdPartyJobSuccessResultCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "PutThirdPartyJobSuccessResultCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutThirdPartyJobSuccessResultInput.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutThirdPartyJobSuccessResultCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1PutThirdPartyJobSuccessResultCommand(input, context);
    };
    PutThirdPartyJobSuccessResultCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1PutThirdPartyJobSuccessResultCommand(output, context);
    };
    return PutThirdPartyJobSuccessResultCommand;
}($Command));
export { PutThirdPartyJobSuccessResultCommand };
