import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutWebhookInput, PutWebhookOutput } from "../models/models_0";
import { deserializeAws_json1_1PutWebhookCommand, serializeAws_json1_1PutWebhookCommand, } from "../protocols/Aws_json1_1";
var PutWebhookCommand = (function (_super) {
    __extends(PutWebhookCommand, _super);
    function PutWebhookCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutWebhookCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "PutWebhookCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutWebhookInput.filterSensitiveLog,
            outputFilterSensitiveLog: PutWebhookOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutWebhookCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1PutWebhookCommand(input, context);
    };
    PutWebhookCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1PutWebhookCommand(output, context);
    };
    return PutWebhookCommand;
}($Command));
export { PutWebhookCommand };
