import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RetryStageExecutionInput, RetryStageExecutionOutput } from "../models/models_0";
import { deserializeAws_json1_1RetryStageExecutionCommand, serializeAws_json1_1RetryStageExecutionCommand, } from "../protocols/Aws_json1_1";
var RetryStageExecutionCommand = (function (_super) {
    __extends(RetryStageExecutionCommand, _super);
    function RetryStageExecutionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RetryStageExecutionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CodePipelineClient";
        var commandName = "RetryStageExecutionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RetryStageExecutionInput.filterSensitiveLog,
            outputFilterSensitiveLog: RetryStageExecutionOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RetryStageExecutionCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1RetryStageExecutionCommand(input, context);
    };
    RetryStageExecutionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1RetryStageExecutionCommand(output, context);
    };
    return RetryStageExecutionCommand;
}($Command));
export { RetryStageExecutionCommand };
