import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { AcknowledgeJobCommandInput, AcknowledgeJobCommandOutput } from "../commands/AcknowledgeJobCommand";
import { AcknowledgeThirdPartyJobCommandInput, AcknowledgeThirdPartyJobCommandOutput } from "../commands/AcknowledgeThirdPartyJobCommand";
import { CreateCustomActionTypeCommandInput, CreateCustomActionTypeCommandOutput } from "../commands/CreateCustomActionTypeCommand";
import { CreatePipelineCommandInput, CreatePipelineCommandOutput } from "../commands/CreatePipelineCommand";
import { DeleteCustomActionTypeCommandInput, DeleteCustomActionTypeCommandOutput } from "../commands/DeleteCustomActionTypeCommand";
import { DeletePipelineCommandInput, DeletePipelineCommandOutput } from "../commands/DeletePipelineCommand";
import { DeleteWebhookCommandInput, DeleteWebhookCommandOutput } from "../commands/DeleteWebhookCommand";
import { DeregisterWebhookWithThirdPartyCommandInput, DeregisterWebhookWithThirdPartyCommandOutput } from "../commands/DeregisterWebhookWithThirdPartyCommand";
import { DisableStageTransitionCommandInput, DisableStageTransitionCommandOutput } from "../commands/DisableStageTransitionCommand";
import { EnableStageTransitionCommandInput, EnableStageTransitionCommandOutput } from "../commands/EnableStageTransitionCommand";
import { GetActionTypeCommandInput, GetActionTypeCommandOutput } from "../commands/GetActionTypeCommand";
import { GetJobDetailsCommandInput, GetJobDetailsCommandOutput } from "../commands/GetJobDetailsCommand";
import { GetPipelineCommandInput, GetPipelineCommandOutput } from "../commands/GetPipelineCommand";
import { GetPipelineExecutionCommandInput, GetPipelineExecutionCommandOutput } from "../commands/GetPipelineExecutionCommand";
import { GetPipelineStateCommandInput, GetPipelineStateCommandOutput } from "../commands/GetPipelineStateCommand";
import { GetThirdPartyJobDetailsCommandInput, GetThirdPartyJobDetailsCommandOutput } from "../commands/GetThirdPartyJobDetailsCommand";
import { ListActionExecutionsCommandInput, ListActionExecutionsCommandOutput } from "../commands/ListActionExecutionsCommand";
import { ListActionTypesCommandInput, ListActionTypesCommandOutput } from "../commands/ListActionTypesCommand";
import { ListPipelineExecutionsCommandInput, ListPipelineExecutionsCommandOutput } from "../commands/ListPipelineExecutionsCommand";
import { ListPipelinesCommandInput, ListPipelinesCommandOutput } from "../commands/ListPipelinesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListWebhooksCommandInput, ListWebhooksCommandOutput } from "../commands/ListWebhooksCommand";
import { PollForJobsCommandInput, PollForJobsCommandOutput } from "../commands/PollForJobsCommand";
import { PollForThirdPartyJobsCommandInput, PollForThirdPartyJobsCommandOutput } from "../commands/PollForThirdPartyJobsCommand";
import { PutActionRevisionCommandInput, PutActionRevisionCommandOutput } from "../commands/PutActionRevisionCommand";
import { PutApprovalResultCommandInput, PutApprovalResultCommandOutput } from "../commands/PutApprovalResultCommand";
import { PutJobFailureResultCommandInput, PutJobFailureResultCommandOutput } from "../commands/PutJobFailureResultCommand";
import { PutJobSuccessResultCommandInput, PutJobSuccessResultCommandOutput } from "../commands/PutJobSuccessResultCommand";
import { PutThirdPartyJobFailureResultCommandInput, PutThirdPartyJobFailureResultCommandOutput } from "../commands/PutThirdPartyJobFailureResultCommand";
import { PutThirdPartyJobSuccessResultCommandInput, PutThirdPartyJobSuccessResultCommandOutput } from "../commands/PutThirdPartyJobSuccessResultCommand";
import { PutWebhookCommandInput, PutWebhookCommandOutput } from "../commands/PutWebhookCommand";
import { RegisterWebhookWithThirdPartyCommandInput, RegisterWebhookWithThirdPartyCommandOutput } from "../commands/RegisterWebhookWithThirdPartyCommand";
import { RetryStageExecutionCommandInput, RetryStageExecutionCommandOutput } from "../commands/RetryStageExecutionCommand";
import { StartPipelineExecutionCommandInput, StartPipelineExecutionCommandOutput } from "../commands/StartPipelineExecutionCommand";
import { StopPipelineExecutionCommandInput, StopPipelineExecutionCommandOutput } from "../commands/StopPipelineExecutionCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateActionTypeCommandInput, UpdateActionTypeCommandOutput } from "../commands/UpdateActionTypeCommand";
import { UpdatePipelineCommandInput, UpdatePipelineCommandOutput } from "../commands/UpdatePipelineCommand";
export declare const serializeAws_json1_1AcknowledgeJobCommand: (input: AcknowledgeJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1AcknowledgeThirdPartyJobCommand: (input: AcknowledgeThirdPartyJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateCustomActionTypeCommand: (input: CreateCustomActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreatePipelineCommand: (input: CreatePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteCustomActionTypeCommand: (input: DeleteCustomActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeletePipelineCommand: (input: DeletePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteWebhookCommand: (input: DeleteWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeregisterWebhookWithThirdPartyCommand: (input: DeregisterWebhookWithThirdPartyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DisableStageTransitionCommand: (input: DisableStageTransitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1EnableStageTransitionCommand: (input: EnableStageTransitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetActionTypeCommand: (input: GetActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetJobDetailsCommand: (input: GetJobDetailsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetPipelineCommand: (input: GetPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetPipelineExecutionCommand: (input: GetPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetPipelineStateCommand: (input: GetPipelineStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetThirdPartyJobDetailsCommand: (input: GetThirdPartyJobDetailsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListActionExecutionsCommand: (input: ListActionExecutionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListActionTypesCommand: (input: ListActionTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListPipelineExecutionsCommand: (input: ListPipelineExecutionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListPipelinesCommand: (input: ListPipelinesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListWebhooksCommand: (input: ListWebhooksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PollForJobsCommand: (input: PollForJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PollForThirdPartyJobsCommand: (input: PollForThirdPartyJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutActionRevisionCommand: (input: PutActionRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutApprovalResultCommand: (input: PutApprovalResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutJobFailureResultCommand: (input: PutJobFailureResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutJobSuccessResultCommand: (input: PutJobSuccessResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutThirdPartyJobFailureResultCommand: (input: PutThirdPartyJobFailureResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutThirdPartyJobSuccessResultCommand: (input: PutThirdPartyJobSuccessResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutWebhookCommand: (input: PutWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RegisterWebhookWithThirdPartyCommand: (input: RegisterWebhookWithThirdPartyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RetryStageExecutionCommand: (input: RetryStageExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StartPipelineExecutionCommand: (input: StartPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StopPipelineExecutionCommand: (input: StopPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateActionTypeCommand: (input: UpdateActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdatePipelineCommand: (input: UpdatePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_json1_1AcknowledgeJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcknowledgeJobCommandOutput>;
export declare const deserializeAws_json1_1AcknowledgeThirdPartyJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcknowledgeThirdPartyJobCommandOutput>;
export declare const deserializeAws_json1_1CreateCustomActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCustomActionTypeCommandOutput>;
export declare const deserializeAws_json1_1CreatePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePipelineCommandOutput>;
export declare const deserializeAws_json1_1DeleteCustomActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCustomActionTypeCommandOutput>;
export declare const deserializeAws_json1_1DeletePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePipelineCommandOutput>;
export declare const deserializeAws_json1_1DeleteWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteWebhookCommandOutput>;
export declare const deserializeAws_json1_1DeregisterWebhookWithThirdPartyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterWebhookWithThirdPartyCommandOutput>;
export declare const deserializeAws_json1_1DisableStageTransitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableStageTransitionCommandOutput>;
export declare const deserializeAws_json1_1EnableStageTransitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableStageTransitionCommandOutput>;
export declare const deserializeAws_json1_1GetActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetActionTypeCommandOutput>;
export declare const deserializeAws_json1_1GetJobDetailsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetJobDetailsCommandOutput>;
export declare const deserializeAws_json1_1GetPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineCommandOutput>;
export declare const deserializeAws_json1_1GetPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineExecutionCommandOutput>;
export declare const deserializeAws_json1_1GetPipelineStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineStateCommandOutput>;
export declare const deserializeAws_json1_1GetThirdPartyJobDetailsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetThirdPartyJobDetailsCommandOutput>;
export declare const deserializeAws_json1_1ListActionExecutionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListActionExecutionsCommandOutput>;
export declare const deserializeAws_json1_1ListActionTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListActionTypesCommandOutput>;
export declare const deserializeAws_json1_1ListPipelineExecutionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPipelineExecutionsCommandOutput>;
export declare const deserializeAws_json1_1ListPipelinesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPipelinesCommandOutput>;
export declare const deserializeAws_json1_1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_json1_1ListWebhooksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListWebhooksCommandOutput>;
export declare const deserializeAws_json1_1PollForJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PollForJobsCommandOutput>;
export declare const deserializeAws_json1_1PollForThirdPartyJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PollForThirdPartyJobsCommandOutput>;
export declare const deserializeAws_json1_1PutActionRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutActionRevisionCommandOutput>;
export declare const deserializeAws_json1_1PutApprovalResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApprovalResultCommandOutput>;
export declare const deserializeAws_json1_1PutJobFailureResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutJobFailureResultCommandOutput>;
export declare const deserializeAws_json1_1PutJobSuccessResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutJobSuccessResultCommandOutput>;
export declare const deserializeAws_json1_1PutThirdPartyJobFailureResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutThirdPartyJobFailureResultCommandOutput>;
export declare const deserializeAws_json1_1PutThirdPartyJobSuccessResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutThirdPartyJobSuccessResultCommandOutput>;
export declare const deserializeAws_json1_1PutWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutWebhookCommandOutput>;
export declare const deserializeAws_json1_1RegisterWebhookWithThirdPartyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterWebhookWithThirdPartyCommandOutput>;
export declare const deserializeAws_json1_1RetryStageExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RetryStageExecutionCommandOutput>;
export declare const deserializeAws_json1_1StartPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartPipelineExecutionCommandOutput>;
export declare const deserializeAws_json1_1StopPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopPipelineExecutionCommandOutput>;
export declare const deserializeAws_json1_1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_json1_1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
export declare const deserializeAws_json1_1UpdateActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateActionTypeCommandOutput>;
export declare const deserializeAws_json1_1UpdatePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePipelineCommandOutput>;
