import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AddRoleToInstanceProfileRequest } from "../models/models_0";
import { deserializeAws_queryAddRoleToInstanceProfileCommand, serializeAws_queryAddRoleToInstanceProfileCommand, } from "../protocols/Aws_query";
var AddRoleToInstanceProfileCommand = (function (_super) {
    __extends(AddRoleToInstanceProfileCommand, _super);
    function AddRoleToInstanceProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AddRoleToInstanceProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "AddRoleToInstanceProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AddRoleToInstanceProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AddRoleToInstanceProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryAddRoleToInstanceProfileCommand(input, context);
    };
    AddRoleToInstanceProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryAddRoleToInstanceProfileCommand(output, context);
    };
    return AddRoleToInstanceProfileCommand;
}($Command));
export { AddRoleToInstanceProfileCommand };
