import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AddUserToGroupRequest } from "../models/models_0";
import { deserializeAws_queryAddUserToGroupCommand, serializeAws_queryAddUserToGroupCommand, } from "../protocols/Aws_query";
var AddUserToGroupCommand = (function (_super) {
    __extends(AddUserToGroupCommand, _super);
    function AddUserToGroupCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AddUserToGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "AddUserToGroupCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AddUserToGroupRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AddUserToGroupCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryAddUserToGroupCommand(input, context);
    };
    AddUserToGroupCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryAddUserToGroupCommand(output, context);
    };
    return AddUserToGroupCommand;
}($Command));
export { AddUserToGroupCommand };
