import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AttachGroupPolicyRequest } from "../models/models_0";
import { deserializeAws_queryAttachGroupPolicyCommand, serializeAws_queryAttachGroupPolicyCommand, } from "../protocols/Aws_query";
var AttachGroupPolicyCommand = (function (_super) {
    __extends(AttachGroupPolicyCommand, _super);
    function AttachGroupPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AttachGroupPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "AttachGroupPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AttachGroupPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AttachGroupPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryAttachGroupPolicyCommand(input, context);
    };
    AttachGroupPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryAttachGroupPolicyCommand(output, context);
    };
    return AttachGroupPolicyCommand;
}($Command));
export { AttachGroupPolicyCommand };
