import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AttachRolePolicyRequest } from "../models/models_0";
import { deserializeAws_queryAttachRolePolicyCommand, serializeAws_queryAttachRolePolicyCommand, } from "../protocols/Aws_query";
var AttachRolePolicyCommand = (function (_super) {
    __extends(AttachRolePolicyCommand, _super);
    function AttachRolePolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AttachRolePolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "AttachRolePolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AttachRolePolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AttachRolePolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryAttachRolePolicyCommand(input, context);
    };
    AttachRolePolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryAttachRolePolicyCommand(output, context);
    };
    return AttachRolePolicyCommand;
}($Command));
export { AttachRolePolicyCommand };
