import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AttachUserPolicyRequest } from "../models/models_0";
import { deserializeAws_queryAttachUserPolicyCommand, serializeAws_queryAttachUserPolicyCommand, } from "../protocols/Aws_query";
var AttachUserPolicyCommand = (function (_super) {
    __extends(AttachUserPolicyCommand, _super);
    function AttachUserPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AttachUserPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "AttachUserPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AttachUserPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AttachUserPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryAttachUserPolicyCommand(input, context);
    };
    AttachUserPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryAttachUserPolicyCommand(output, context);
    };
    return AttachUserPolicyCommand;
}($Command));
export { AttachUserPolicyCommand };
