import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateAccessKeyRequest, CreateAccessKeyResponse } from "../models/models_0";
import { deserializeAws_queryCreateAccessKeyCommand, serializeAws_queryCreateAccessKeyCommand, } from "../protocols/Aws_query";
var CreateAccessKeyCommand = (function (_super) {
    __extends(CreateAccessKeyCommand, _super);
    function CreateAccessKeyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateAccessKeyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "CreateAccessKeyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateAccessKeyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateAccessKeyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateAccessKeyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateAccessKeyCommand(input, context);
    };
    CreateAccessKeyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateAccessKeyCommand(output, context);
    };
    return CreateAccessKeyCommand;
}($Command));
export { CreateAccessKeyCommand };
