import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateAccountAliasRequest } from "../models/models_0";
import { deserializeAws_queryCreateAccountAliasCommand, serializeAws_queryCreateAccountAliasCommand, } from "../protocols/Aws_query";
var CreateAccountAliasCommand = (function (_super) {
    __extends(CreateAccountAliasCommand, _super);
    function CreateAccountAliasCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateAccountAliasCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "CreateAccountAliasCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateAccountAliasRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateAccountAliasCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateAccountAliasCommand(input, context);
    };
    CreateAccountAliasCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateAccountAliasCommand(output, context);
    };
    return CreateAccountAliasCommand;
}($Command));
export { CreateAccountAliasCommand };
