import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateLoginProfileRequest, CreateLoginProfileResponse } from "../models/models_0";
import { deserializeAws_queryCreateLoginProfileCommand, serializeAws_queryCreateLoginProfileCommand, } from "../protocols/Aws_query";
var CreateLoginProfileCommand = (function (_super) {
    __extends(CreateLoginProfileCommand, _super);
    function CreateLoginProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateLoginProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "CreateLoginProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateLoginProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateLoginProfileResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateLoginProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateLoginProfileCommand(input, context);
    };
    CreateLoginProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateLoginProfileCommand(output, context);
    };
    return CreateLoginProfileCommand;
}($Command));
export { CreateLoginProfileCommand };
