import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateSAMLProviderRequest, CreateSAMLProviderResponse } from "../models/models_0";
import { deserializeAws_queryCreateSAMLProviderCommand, serializeAws_queryCreateSAMLProviderCommand, } from "../protocols/Aws_query";
var CreateSAMLProviderCommand = (function (_super) {
    __extends(CreateSAMLProviderCommand, _super);
    function CreateSAMLProviderCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateSAMLProviderCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "CreateSAMLProviderCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateSAMLProviderRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateSAMLProviderResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateSAMLProviderCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateSAMLProviderCommand(input, context);
    };
    CreateSAMLProviderCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateSAMLProviderCommand(output, context);
    };
    return CreateSAMLProviderCommand;
}($Command));
export { CreateSAMLProviderCommand };
