import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateVirtualMFADeviceRequest, CreateVirtualMFADeviceResponse } from "../models/models_0";
import { deserializeAws_queryCreateVirtualMFADeviceCommand, serializeAws_queryCreateVirtualMFADeviceCommand, } from "../protocols/Aws_query";
var CreateVirtualMFADeviceCommand = (function (_super) {
    __extends(CreateVirtualMFADeviceCommand, _super);
    function CreateVirtualMFADeviceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateVirtualMFADeviceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "CreateVirtualMFADeviceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateVirtualMFADeviceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateVirtualMFADeviceResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateVirtualMFADeviceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCreateVirtualMFADeviceCommand(input, context);
    };
    CreateVirtualMFADeviceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCreateVirtualMFADeviceCommand(output, context);
    };
    return CreateVirtualMFADeviceCommand;
}($Command));
export { CreateVirtualMFADeviceCommand };
