import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteAccountAliasRequest } from "../models/models_0";
import { deserializeAws_queryDeleteAccountAliasCommand, serializeAws_queryDeleteAccountAliasCommand, } from "../protocols/Aws_query";
var DeleteAccountAliasCommand = (function (_super) {
    __extends(DeleteAccountAliasCommand, _super);
    function DeleteAccountAliasCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteAccountAliasCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteAccountAliasCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteAccountAliasRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteAccountAliasCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteAccountAliasCommand(input, context);
    };
    DeleteAccountAliasCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteAccountAliasCommand(output, context);
    };
    return DeleteAccountAliasCommand;
}($Command));
export { DeleteAccountAliasCommand };
