import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteGroupPolicyRequest } from "../models/models_0";
import { deserializeAws_queryDeleteGroupPolicyCommand, serializeAws_queryDeleteGroupPolicyCommand, } from "../protocols/Aws_query";
var DeleteGroupPolicyCommand = (function (_super) {
    __extends(DeleteGroupPolicyCommand, _super);
    function DeleteGroupPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteGroupPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteGroupPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteGroupPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteGroupPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteGroupPolicyCommand(input, context);
    };
    DeleteGroupPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteGroupPolicyCommand(output, context);
    };
    return DeleteGroupPolicyCommand;
}($Command));
export { DeleteGroupPolicyCommand };
