import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeletePolicyVersionRequest } from "../models/models_0";
import { deserializeAws_queryDeletePolicyVersionCommand, serializeAws_queryDeletePolicyVersionCommand, } from "../protocols/Aws_query";
var DeletePolicyVersionCommand = (function (_super) {
    __extends(DeletePolicyVersionCommand, _super);
    function DeletePolicyVersionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeletePolicyVersionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeletePolicyVersionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeletePolicyVersionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeletePolicyVersionCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeletePolicyVersionCommand(input, context);
    };
    DeletePolicyVersionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeletePolicyVersionCommand(output, context);
    };
    return DeletePolicyVersionCommand;
}($Command));
export { DeletePolicyVersionCommand };
