import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteRolePermissionsBoundaryRequest } from "../models/models_0";
import { deserializeAws_queryDeleteRolePermissionsBoundaryCommand, serializeAws_queryDeleteRolePermissionsBoundaryCommand, } from "../protocols/Aws_query";
var DeleteRolePermissionsBoundaryCommand = (function (_super) {
    __extends(DeleteRolePermissionsBoundaryCommand, _super);
    function DeleteRolePermissionsBoundaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteRolePermissionsBoundaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteRolePermissionsBoundaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteRolePermissionsBoundaryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteRolePermissionsBoundaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteRolePermissionsBoundaryCommand(input, context);
    };
    DeleteRolePermissionsBoundaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteRolePermissionsBoundaryCommand(output, context);
    };
    return DeleteRolePermissionsBoundaryCommand;
}($Command));
export { DeleteRolePermissionsBoundaryCommand };
