import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteServerCertificateRequest } from "../models/models_0";
import { deserializeAws_queryDeleteServerCertificateCommand, serializeAws_queryDeleteServerCertificateCommand, } from "../protocols/Aws_query";
var DeleteServerCertificateCommand = (function (_super) {
    __extends(DeleteServerCertificateCommand, _super);
    function DeleteServerCertificateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteServerCertificateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteServerCertificateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteServerCertificateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteServerCertificateCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteServerCertificateCommand(input, context);
    };
    DeleteServerCertificateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteServerCertificateCommand(output, context);
    };
    return DeleteServerCertificateCommand;
}($Command));
export { DeleteServerCertificateCommand };
