import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteUserPermissionsBoundaryRequest } from "../models/models_0";
import { deserializeAws_queryDeleteUserPermissionsBoundaryCommand, serializeAws_queryDeleteUserPermissionsBoundaryCommand, } from "../protocols/Aws_query";
var DeleteUserPermissionsBoundaryCommand = (function (_super) {
    __extends(DeleteUserPermissionsBoundaryCommand, _super);
    function DeleteUserPermissionsBoundaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteUserPermissionsBoundaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteUserPermissionsBoundaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteUserPermissionsBoundaryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteUserPermissionsBoundaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteUserPermissionsBoundaryCommand(input, context);
    };
    DeleteUserPermissionsBoundaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteUserPermissionsBoundaryCommand(output, context);
    };
    return DeleteUserPermissionsBoundaryCommand;
}($Command));
export { DeleteUserPermissionsBoundaryCommand };
