import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteVirtualMFADeviceRequest } from "../models/models_0";
import { deserializeAws_queryDeleteVirtualMFADeviceCommand, serializeAws_queryDeleteVirtualMFADeviceCommand, } from "../protocols/Aws_query";
var DeleteVirtualMFADeviceCommand = (function (_super) {
    __extends(DeleteVirtualMFADeviceCommand, _super);
    function DeleteVirtualMFADeviceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteVirtualMFADeviceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "DeleteVirtualMFADeviceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteVirtualMFADeviceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteVirtualMFADeviceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteVirtualMFADeviceCommand(input, context);
    };
    DeleteVirtualMFADeviceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteVirtualMFADeviceCommand(output, context);
    };
    return DeleteVirtualMFADeviceCommand;
}($Command));
export { DeleteVirtualMFADeviceCommand };
