import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { EnableMFADeviceRequest } from "../models/models_0";
import { deserializeAws_queryEnableMFADeviceCommand, serializeAws_queryEnableMFADeviceCommand, } from "../protocols/Aws_query";
var EnableMFADeviceCommand = (function (_super) {
    __extends(EnableMFADeviceCommand, _super);
    function EnableMFADeviceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    EnableMFADeviceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "EnableMFADeviceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: EnableMFADeviceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    EnableMFADeviceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryEnableMFADeviceCommand(input, context);
    };
    EnableMFADeviceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryEnableMFADeviceCommand(output, context);
    };
    return EnableMFADeviceCommand;
}($Command));
export { EnableMFADeviceCommand };
