import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GenerateCredentialReportResponse } from "../models/models_0";
import { deserializeAws_queryGenerateCredentialReportCommand, serializeAws_queryGenerateCredentialReportCommand, } from "../protocols/Aws_query";
var GenerateCredentialReportCommand = (function (_super) {
    __extends(GenerateCredentialReportCommand, _super);
    function GenerateCredentialReportCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GenerateCredentialReportCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GenerateCredentialReportCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: function (input) { return input; },
            outputFilterSensitiveLog: GenerateCredentialReportResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GenerateCredentialReportCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGenerateCredentialReportCommand(input, context);
    };
    GenerateCredentialReportCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGenerateCredentialReportCommand(output, context);
    };
    return GenerateCredentialReportCommand;
}($Command));
export { GenerateCredentialReportCommand };
