import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GenerateOrganizationsAccessReportRequest, GenerateOrganizationsAccessReportResponse, } from "../models/models_0";
import { deserializeAws_queryGenerateOrganizationsAccessReportCommand, serializeAws_queryGenerateOrganizationsAccessReportCommand, } from "../protocols/Aws_query";
var GenerateOrganizationsAccessReportCommand = (function (_super) {
    __extends(GenerateOrganizationsAccessReportCommand, _super);
    function GenerateOrganizationsAccessReportCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GenerateOrganizationsAccessReportCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GenerateOrganizationsAccessReportCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GenerateOrganizationsAccessReportRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GenerateOrganizationsAccessReportResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GenerateOrganizationsAccessReportCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGenerateOrganizationsAccessReportCommand(input, context);
    };
    GenerateOrganizationsAccessReportCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGenerateOrganizationsAccessReportCommand(output, context);
    };
    return GenerateOrganizationsAccessReportCommand;
}($Command));
export { GenerateOrganizationsAccessReportCommand };
