import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetAccountSummaryResponse } from "../models/models_0";
import { deserializeAws_queryGetAccountSummaryCommand, serializeAws_queryGetAccountSummaryCommand, } from "../protocols/Aws_query";
var GetAccountSummaryCommand = (function (_super) {
    __extends(GetAccountSummaryCommand, _super);
    function GetAccountSummaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetAccountSummaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetAccountSummaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: function (input) { return input; },
            outputFilterSensitiveLog: GetAccountSummaryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetAccountSummaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetAccountSummaryCommand(input, context);
    };
    GetAccountSummaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetAccountSummaryCommand(output, context);
    };
    return GetAccountSummaryCommand;
}($Command));
export { GetAccountSummaryCommand };
