import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetContextKeysForPolicyResponse, GetContextKeysForPrincipalPolicyRequest } from "../models/models_0";
import { deserializeAws_queryGetContextKeysForPrincipalPolicyCommand, serializeAws_queryGetContextKeysForPrincipalPolicyCommand, } from "../protocols/Aws_query";
var GetContextKeysForPrincipalPolicyCommand = (function (_super) {
    __extends(GetContextKeysForPrincipalPolicyCommand, _super);
    function GetContextKeysForPrincipalPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetContextKeysForPrincipalPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetContextKeysForPrincipalPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetContextKeysForPrincipalPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetContextKeysForPolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetContextKeysForPrincipalPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetContextKeysForPrincipalPolicyCommand(input, context);
    };
    GetContextKeysForPrincipalPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetContextKeysForPrincipalPolicyCommand(output, context);
    };
    return GetContextKeysForPrincipalPolicyCommand;
}($Command));
export { GetContextKeysForPrincipalPolicyCommand };
