import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetCredentialReportResponse } from "../models/models_0";
import { deserializeAws_queryGetCredentialReportCommand, serializeAws_queryGetCredentialReportCommand, } from "../protocols/Aws_query";
var GetCredentialReportCommand = (function (_super) {
    __extends(GetCredentialReportCommand, _super);
    function GetCredentialReportCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetCredentialReportCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetCredentialReportCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: function (input) { return input; },
            outputFilterSensitiveLog: GetCredentialReportResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetCredentialReportCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetCredentialReportCommand(input, context);
    };
    GetCredentialReportCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetCredentialReportCommand(output, context);
    };
    return GetCredentialReportCommand;
}($Command));
export { GetCredentialReportCommand };
