import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetGroupRequest, GetGroupResponse } from "../models/models_0";
import { deserializeAws_queryGetGroupCommand, serializeAws_queryGetGroupCommand } from "../protocols/Aws_query";
var GetGroupCommand = (function (_super) {
    __extends(GetGroupCommand, _super);
    function GetGroupCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetGroupCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetGroupCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetGroupRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetGroupResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetGroupCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetGroupCommand(input, context);
    };
    GetGroupCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetGroupCommand(output, context);
    };
    return GetGroupCommand;
}($Command));
export { GetGroupCommand };
