import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetGroupPolicyRequest, GetGroupPolicyResponse } from "../models/models_0";
import { deserializeAws_queryGetGroupPolicyCommand, serializeAws_queryGetGroupPolicyCommand, } from "../protocols/Aws_query";
var GetGroupPolicyCommand = (function (_super) {
    __extends(GetGroupPolicyCommand, _super);
    function GetGroupPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetGroupPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetGroupPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetGroupPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetGroupPolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetGroupPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetGroupPolicyCommand(input, context);
    };
    GetGroupPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetGroupPolicyCommand(output, context);
    };
    return GetGroupPolicyCommand;
}($Command));
export { GetGroupPolicyCommand };
