import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetLoginProfileRequest, GetLoginProfileResponse } from "../models/models_0";
import { deserializeAws_queryGetLoginProfileCommand, serializeAws_queryGetLoginProfileCommand, } from "../protocols/Aws_query";
var GetLoginProfileCommand = (function (_super) {
    __extends(GetLoginProfileCommand, _super);
    function GetLoginProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetLoginProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetLoginProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetLoginProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetLoginProfileResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetLoginProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetLoginProfileCommand(input, context);
    };
    GetLoginProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetLoginProfileCommand(output, context);
    };
    return GetLoginProfileCommand;
}($Command));
export { GetLoginProfileCommand };
