import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetOpenIDConnectProviderRequest, GetOpenIDConnectProviderResponse } from "../models/models_0";
import { deserializeAws_queryGetOpenIDConnectProviderCommand, serializeAws_queryGetOpenIDConnectProviderCommand, } from "../protocols/Aws_query";
var GetOpenIDConnectProviderCommand = (function (_super) {
    __extends(GetOpenIDConnectProviderCommand, _super);
    function GetOpenIDConnectProviderCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetOpenIDConnectProviderCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetOpenIDConnectProviderCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetOpenIDConnectProviderRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetOpenIDConnectProviderResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetOpenIDConnectProviderCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetOpenIDConnectProviderCommand(input, context);
    };
    GetOpenIDConnectProviderCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetOpenIDConnectProviderCommand(output, context);
    };
    return GetOpenIDConnectProviderCommand;
}($Command));
export { GetOpenIDConnectProviderCommand };
