import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetOrganizationsAccessReportRequest, GetOrganizationsAccessReportResponse } from "../models/models_0";
import { deserializeAws_queryGetOrganizationsAccessReportCommand, serializeAws_queryGetOrganizationsAccessReportCommand, } from "../protocols/Aws_query";
var GetOrganizationsAccessReportCommand = (function (_super) {
    __extends(GetOrganizationsAccessReportCommand, _super);
    function GetOrganizationsAccessReportCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetOrganizationsAccessReportCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetOrganizationsAccessReportCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetOrganizationsAccessReportRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetOrganizationsAccessReportResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetOrganizationsAccessReportCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetOrganizationsAccessReportCommand(input, context);
    };
    GetOrganizationsAccessReportCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetOrganizationsAccessReportCommand(output, context);
    };
    return GetOrganizationsAccessReportCommand;
}($Command));
export { GetOrganizationsAccessReportCommand };
