import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetPolicyVersionRequest, GetPolicyVersionResponse } from "../models/models_0";
import { deserializeAws_queryGetPolicyVersionCommand, serializeAws_queryGetPolicyVersionCommand, } from "../protocols/Aws_query";
var GetPolicyVersionCommand = (function (_super) {
    __extends(GetPolicyVersionCommand, _super);
    function GetPolicyVersionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetPolicyVersionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetPolicyVersionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetPolicyVersionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetPolicyVersionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetPolicyVersionCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetPolicyVersionCommand(input, context);
    };
    GetPolicyVersionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetPolicyVersionCommand(output, context);
    };
    return GetPolicyVersionCommand;
}($Command));
export { GetPolicyVersionCommand };
