import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetRoleRequest, GetRoleResponse } from "../models/models_0";
import { deserializeAws_queryGetRoleCommand, serializeAws_queryGetRoleCommand } from "../protocols/Aws_query";
var GetRoleCommand = (function (_super) {
    __extends(GetRoleCommand, _super);
    function GetRoleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetRoleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetRoleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetRoleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetRoleResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetRoleCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetRoleCommand(input, context);
    };
    GetRoleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetRoleCommand(output, context);
    };
    return GetRoleCommand;
}($Command));
export { GetRoleCommand };
