import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetRolePolicyRequest, GetRolePolicyResponse } from "../models/models_0";
import { deserializeAws_queryGetRolePolicyCommand, serializeAws_queryGetRolePolicyCommand, } from "../protocols/Aws_query";
var GetRolePolicyCommand = (function (_super) {
    __extends(GetRolePolicyCommand, _super);
    function GetRolePolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetRolePolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetRolePolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetRolePolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetRolePolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetRolePolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetRolePolicyCommand(input, context);
    };
    GetRolePolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetRolePolicyCommand(output, context);
    };
    return GetRolePolicyCommand;
}($Command));
export { GetRolePolicyCommand };
