import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetSAMLProviderRequest, GetSAMLProviderResponse } from "../models/models_0";
import { deserializeAws_queryGetSAMLProviderCommand, serializeAws_queryGetSAMLProviderCommand, } from "../protocols/Aws_query";
var GetSAMLProviderCommand = (function (_super) {
    __extends(GetSAMLProviderCommand, _super);
    function GetSAMLProviderCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetSAMLProviderCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetSAMLProviderCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetSAMLProviderRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetSAMLProviderResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetSAMLProviderCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetSAMLProviderCommand(input, context);
    };
    GetSAMLProviderCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetSAMLProviderCommand(output, context);
    };
    return GetSAMLProviderCommand;
}($Command));
export { GetSAMLProviderCommand };
