import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetServiceLastAccessedDetailsWithEntitiesRequest, GetServiceLastAccessedDetailsWithEntitiesResponse, } from "../models/models_0";
import { deserializeAws_queryGetServiceLastAccessedDetailsWithEntitiesCommand, serializeAws_queryGetServiceLastAccessedDetailsWithEntitiesCommand, } from "../protocols/Aws_query";
var GetServiceLastAccessedDetailsWithEntitiesCommand = (function (_super) {
    __extends(GetServiceLastAccessedDetailsWithEntitiesCommand, _super);
    function GetServiceLastAccessedDetailsWithEntitiesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetServiceLastAccessedDetailsWithEntitiesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetServiceLastAccessedDetailsWithEntitiesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetServiceLastAccessedDetailsWithEntitiesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetServiceLastAccessedDetailsWithEntitiesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetServiceLastAccessedDetailsWithEntitiesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetServiceLastAccessedDetailsWithEntitiesCommand(input, context);
    };
    GetServiceLastAccessedDetailsWithEntitiesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetServiceLastAccessedDetailsWithEntitiesCommand(output, context);
    };
    return GetServiceLastAccessedDetailsWithEntitiesCommand;
}($Command));
export { GetServiceLastAccessedDetailsWithEntitiesCommand };
