import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetServiceLinkedRoleDeletionStatusRequest, GetServiceLinkedRoleDeletionStatusResponse, } from "../models/models_0";
import { deserializeAws_queryGetServiceLinkedRoleDeletionStatusCommand, serializeAws_queryGetServiceLinkedRoleDeletionStatusCommand, } from "../protocols/Aws_query";
var GetServiceLinkedRoleDeletionStatusCommand = (function (_super) {
    __extends(GetServiceLinkedRoleDeletionStatusCommand, _super);
    function GetServiceLinkedRoleDeletionStatusCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetServiceLinkedRoleDeletionStatusCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "GetServiceLinkedRoleDeletionStatusCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetServiceLinkedRoleDeletionStatusRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetServiceLinkedRoleDeletionStatusResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetServiceLinkedRoleDeletionStatusCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetServiceLinkedRoleDeletionStatusCommand(input, context);
    };
    GetServiceLinkedRoleDeletionStatusCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetServiceLinkedRoleDeletionStatusCommand(output, context);
    };
    return GetServiceLinkedRoleDeletionStatusCommand;
}($Command));
export { GetServiceLinkedRoleDeletionStatusCommand };
