import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListAttachedGroupPoliciesRequest, ListAttachedGroupPoliciesResponse } from "../models/models_0";
import { deserializeAws_queryListAttachedGroupPoliciesCommand, serializeAws_queryListAttachedGroupPoliciesCommand, } from "../protocols/Aws_query";
var ListAttachedGroupPoliciesCommand = (function (_super) {
    __extends(ListAttachedGroupPoliciesCommand, _super);
    function ListAttachedGroupPoliciesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListAttachedGroupPoliciesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListAttachedGroupPoliciesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListAttachedGroupPoliciesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListAttachedGroupPoliciesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListAttachedGroupPoliciesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListAttachedGroupPoliciesCommand(input, context);
    };
    ListAttachedGroupPoliciesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListAttachedGroupPoliciesCommand(output, context);
    };
    return ListAttachedGroupPoliciesCommand;
}($Command));
export { ListAttachedGroupPoliciesCommand };
