import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListAttachedRolePoliciesRequest, ListAttachedRolePoliciesResponse } from "../models/models_0";
import { deserializeAws_queryListAttachedRolePoliciesCommand, serializeAws_queryListAttachedRolePoliciesCommand, } from "../protocols/Aws_query";
var ListAttachedRolePoliciesCommand = (function (_super) {
    __extends(ListAttachedRolePoliciesCommand, _super);
    function ListAttachedRolePoliciesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListAttachedRolePoliciesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListAttachedRolePoliciesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListAttachedRolePoliciesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListAttachedRolePoliciesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListAttachedRolePoliciesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListAttachedRolePoliciesCommand(input, context);
    };
    ListAttachedRolePoliciesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListAttachedRolePoliciesCommand(output, context);
    };
    return ListAttachedRolePoliciesCommand;
}($Command));
export { ListAttachedRolePoliciesCommand };
