import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListAttachedUserPoliciesRequest, ListAttachedUserPoliciesResponse } from "../models/models_0";
import { deserializeAws_queryListAttachedUserPoliciesCommand, serializeAws_queryListAttachedUserPoliciesCommand, } from "../protocols/Aws_query";
var ListAttachedUserPoliciesCommand = (function (_super) {
    __extends(ListAttachedUserPoliciesCommand, _super);
    function ListAttachedUserPoliciesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListAttachedUserPoliciesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListAttachedUserPoliciesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListAttachedUserPoliciesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListAttachedUserPoliciesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListAttachedUserPoliciesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListAttachedUserPoliciesCommand(input, context);
    };
    ListAttachedUserPoliciesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListAttachedUserPoliciesCommand(output, context);
    };
    return ListAttachedUserPoliciesCommand;
}($Command));
export { ListAttachedUserPoliciesCommand };
