import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListEntitiesForPolicyRequest, ListEntitiesForPolicyResponse } from "../models/models_0";
import { deserializeAws_queryListEntitiesForPolicyCommand, serializeAws_queryListEntitiesForPolicyCommand, } from "../protocols/Aws_query";
var ListEntitiesForPolicyCommand = (function (_super) {
    __extends(ListEntitiesForPolicyCommand, _super);
    function ListEntitiesForPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListEntitiesForPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListEntitiesForPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListEntitiesForPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListEntitiesForPolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListEntitiesForPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListEntitiesForPolicyCommand(input, context);
    };
    ListEntitiesForPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListEntitiesForPolicyCommand(output, context);
    };
    return ListEntitiesForPolicyCommand;
}($Command));
export { ListEntitiesForPolicyCommand };
