import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListGroupsForUserRequest, ListGroupsForUserResponse } from "../models/models_0";
import { deserializeAws_queryListGroupsForUserCommand, serializeAws_queryListGroupsForUserCommand, } from "../protocols/Aws_query";
var ListGroupsForUserCommand = (function (_super) {
    __extends(ListGroupsForUserCommand, _super);
    function ListGroupsForUserCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListGroupsForUserCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListGroupsForUserCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListGroupsForUserRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListGroupsForUserResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListGroupsForUserCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListGroupsForUserCommand(input, context);
    };
    ListGroupsForUserCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListGroupsForUserCommand(output, context);
    };
    return ListGroupsForUserCommand;
}($Command));
export { ListGroupsForUserCommand };
