import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListInstanceProfileTagsRequest, ListInstanceProfileTagsResponse } from "../models/models_0";
import { deserializeAws_queryListInstanceProfileTagsCommand, serializeAws_queryListInstanceProfileTagsCommand, } from "../protocols/Aws_query";
var ListInstanceProfileTagsCommand = (function (_super) {
    __extends(ListInstanceProfileTagsCommand, _super);
    function ListInstanceProfileTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListInstanceProfileTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListInstanceProfileTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListInstanceProfileTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListInstanceProfileTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListInstanceProfileTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListInstanceProfileTagsCommand(input, context);
    };
    ListInstanceProfileTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListInstanceProfileTagsCommand(output, context);
    };
    return ListInstanceProfileTagsCommand;
}($Command));
export { ListInstanceProfileTagsCommand };
