import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListInstanceProfilesForRoleRequest, ListInstanceProfilesForRoleResponse } from "../models/models_0";
import { deserializeAws_queryListInstanceProfilesForRoleCommand, serializeAws_queryListInstanceProfilesForRoleCommand, } from "../protocols/Aws_query";
var ListInstanceProfilesForRoleCommand = (function (_super) {
    __extends(ListInstanceProfilesForRoleCommand, _super);
    function ListInstanceProfilesForRoleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListInstanceProfilesForRoleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListInstanceProfilesForRoleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListInstanceProfilesForRoleRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListInstanceProfilesForRoleResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListInstanceProfilesForRoleCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListInstanceProfilesForRoleCommand(input, context);
    };
    ListInstanceProfilesForRoleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListInstanceProfilesForRoleCommand(output, context);
    };
    return ListInstanceProfilesForRoleCommand;
}($Command));
export { ListInstanceProfilesForRoleCommand };
