import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListMFADeviceTagsRequest, ListMFADeviceTagsResponse } from "../models/models_0";
import { deserializeAws_queryListMFADeviceTagsCommand, serializeAws_queryListMFADeviceTagsCommand, } from "../protocols/Aws_query";
var ListMFADeviceTagsCommand = (function (_super) {
    __extends(ListMFADeviceTagsCommand, _super);
    function ListMFADeviceTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListMFADeviceTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListMFADeviceTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListMFADeviceTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListMFADeviceTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListMFADeviceTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListMFADeviceTagsCommand(input, context);
    };
    ListMFADeviceTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListMFADeviceTagsCommand(output, context);
    };
    return ListMFADeviceTagsCommand;
}($Command));
export { ListMFADeviceTagsCommand };
