import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListOpenIDConnectProviderTagsRequest, ListOpenIDConnectProviderTagsResponse } from "../models/models_0";
import { deserializeAws_queryListOpenIDConnectProviderTagsCommand, serializeAws_queryListOpenIDConnectProviderTagsCommand, } from "../protocols/Aws_query";
var ListOpenIDConnectProviderTagsCommand = (function (_super) {
    __extends(ListOpenIDConnectProviderTagsCommand, _super);
    function ListOpenIDConnectProviderTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListOpenIDConnectProviderTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListOpenIDConnectProviderTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListOpenIDConnectProviderTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListOpenIDConnectProviderTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListOpenIDConnectProviderTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListOpenIDConnectProviderTagsCommand(input, context);
    };
    ListOpenIDConnectProviderTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListOpenIDConnectProviderTagsCommand(output, context);
    };
    return ListOpenIDConnectProviderTagsCommand;
}($Command));
export { ListOpenIDConnectProviderTagsCommand };
