import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPoliciesGrantingServiceAccessRequest, ListPoliciesGrantingServiceAccessResponse, } from "../models/models_0";
import { deserializeAws_queryListPoliciesGrantingServiceAccessCommand, serializeAws_queryListPoliciesGrantingServiceAccessCommand, } from "../protocols/Aws_query";
var ListPoliciesGrantingServiceAccessCommand = (function (_super) {
    __extends(ListPoliciesGrantingServiceAccessCommand, _super);
    function ListPoliciesGrantingServiceAccessCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPoliciesGrantingServiceAccessCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListPoliciesGrantingServiceAccessCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPoliciesGrantingServiceAccessRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListPoliciesGrantingServiceAccessResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPoliciesGrantingServiceAccessCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListPoliciesGrantingServiceAccessCommand(input, context);
    };
    ListPoliciesGrantingServiceAccessCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListPoliciesGrantingServiceAccessCommand(output, context);
    };
    return ListPoliciesGrantingServiceAccessCommand;
}($Command));
export { ListPoliciesGrantingServiceAccessCommand };
