import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPolicyTagsRequest, ListPolicyTagsResponse } from "../models/models_0";
import { deserializeAws_queryListPolicyTagsCommand, serializeAws_queryListPolicyTagsCommand, } from "../protocols/Aws_query";
var ListPolicyTagsCommand = (function (_super) {
    __extends(ListPolicyTagsCommand, _super);
    function ListPolicyTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPolicyTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListPolicyTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPolicyTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListPolicyTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPolicyTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListPolicyTagsCommand(input, context);
    };
    ListPolicyTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListPolicyTagsCommand(output, context);
    };
    return ListPolicyTagsCommand;
}($Command));
export { ListPolicyTagsCommand };
