import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListPolicyVersionsRequest, ListPolicyVersionsResponse } from "../models/models_0";
import { deserializeAws_queryListPolicyVersionsCommand, serializeAws_queryListPolicyVersionsCommand, } from "../protocols/Aws_query";
var ListPolicyVersionsCommand = (function (_super) {
    __extends(ListPolicyVersionsCommand, _super);
    function ListPolicyVersionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListPolicyVersionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListPolicyVersionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListPolicyVersionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListPolicyVersionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListPolicyVersionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListPolicyVersionsCommand(input, context);
    };
    ListPolicyVersionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListPolicyVersionsCommand(output, context);
    };
    return ListPolicyVersionsCommand;
}($Command));
export { ListPolicyVersionsCommand };
