import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListRoleTagsRequest, ListRoleTagsResponse } from "../models/models_0";
import { deserializeAws_queryListRoleTagsCommand, serializeAws_queryListRoleTagsCommand } from "../protocols/Aws_query";
var ListRoleTagsCommand = (function (_super) {
    __extends(ListRoleTagsCommand, _super);
    function ListRoleTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListRoleTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListRoleTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListRoleTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListRoleTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListRoleTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListRoleTagsCommand(input, context);
    };
    ListRoleTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListRoleTagsCommand(output, context);
    };
    return ListRoleTagsCommand;
}($Command));
export { ListRoleTagsCommand };
