import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListSSHPublicKeysRequest, ListSSHPublicKeysResponse } from "../models/models_0";
import { deserializeAws_queryListSSHPublicKeysCommand, serializeAws_queryListSSHPublicKeysCommand, } from "../protocols/Aws_query";
var ListSSHPublicKeysCommand = (function (_super) {
    __extends(ListSSHPublicKeysCommand, _super);
    function ListSSHPublicKeysCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListSSHPublicKeysCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListSSHPublicKeysCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListSSHPublicKeysRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListSSHPublicKeysResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListSSHPublicKeysCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListSSHPublicKeysCommand(input, context);
    };
    ListSSHPublicKeysCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListSSHPublicKeysCommand(output, context);
    };
    return ListSSHPublicKeysCommand;
}($Command));
export { ListSSHPublicKeysCommand };
