import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListServerCertificateTagsRequest, ListServerCertificateTagsResponse } from "../models/models_0";
import { deserializeAws_queryListServerCertificateTagsCommand, serializeAws_queryListServerCertificateTagsCommand, } from "../protocols/Aws_query";
var ListServerCertificateTagsCommand = (function (_super) {
    __extends(ListServerCertificateTagsCommand, _super);
    function ListServerCertificateTagsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListServerCertificateTagsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListServerCertificateTagsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListServerCertificateTagsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListServerCertificateTagsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListServerCertificateTagsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListServerCertificateTagsCommand(input, context);
    };
    ListServerCertificateTagsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListServerCertificateTagsCommand(output, context);
    };
    return ListServerCertificateTagsCommand;
}($Command));
export { ListServerCertificateTagsCommand };
