import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListServiceSpecificCredentialsRequest, ListServiceSpecificCredentialsResponse } from "../models/models_0";
import { deserializeAws_queryListServiceSpecificCredentialsCommand, serializeAws_queryListServiceSpecificCredentialsCommand, } from "../protocols/Aws_query";
var ListServiceSpecificCredentialsCommand = (function (_super) {
    __extends(ListServiceSpecificCredentialsCommand, _super);
    function ListServiceSpecificCredentialsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListServiceSpecificCredentialsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListServiceSpecificCredentialsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListServiceSpecificCredentialsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListServiceSpecificCredentialsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListServiceSpecificCredentialsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListServiceSpecificCredentialsCommand(input, context);
    };
    ListServiceSpecificCredentialsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListServiceSpecificCredentialsCommand(output, context);
    };
    return ListServiceSpecificCredentialsCommand;
}($Command));
export { ListServiceSpecificCredentialsCommand };
