import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListSigningCertificatesRequest, ListSigningCertificatesResponse } from "../models/models_0";
import { deserializeAws_queryListSigningCertificatesCommand, serializeAws_queryListSigningCertificatesCommand, } from "../protocols/Aws_query";
var ListSigningCertificatesCommand = (function (_super) {
    __extends(ListSigningCertificatesCommand, _super);
    function ListSigningCertificatesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListSigningCertificatesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListSigningCertificatesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListSigningCertificatesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListSigningCertificatesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListSigningCertificatesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListSigningCertificatesCommand(input, context);
    };
    ListSigningCertificatesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListSigningCertificatesCommand(output, context);
    };
    return ListSigningCertificatesCommand;
}($Command));
export { ListSigningCertificatesCommand };
