import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListVirtualMFADevicesRequest, ListVirtualMFADevicesResponse } from "../models/models_0";
import { deserializeAws_queryListVirtualMFADevicesCommand, serializeAws_queryListVirtualMFADevicesCommand, } from "../protocols/Aws_query";
var ListVirtualMFADevicesCommand = (function (_super) {
    __extends(ListVirtualMFADevicesCommand, _super);
    function ListVirtualMFADevicesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListVirtualMFADevicesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ListVirtualMFADevicesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListVirtualMFADevicesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListVirtualMFADevicesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListVirtualMFADevicesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListVirtualMFADevicesCommand(input, context);
    };
    ListVirtualMFADevicesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListVirtualMFADevicesCommand(output, context);
    };
    return ListVirtualMFADevicesCommand;
}($Command));
export { ListVirtualMFADevicesCommand };
