import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutGroupPolicyRequest } from "../models/models_0";
import { deserializeAws_queryPutGroupPolicyCommand, serializeAws_queryPutGroupPolicyCommand, } from "../protocols/Aws_query";
var PutGroupPolicyCommand = (function (_super) {
    __extends(PutGroupPolicyCommand, _super);
    function PutGroupPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutGroupPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "PutGroupPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutGroupPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutGroupPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutGroupPolicyCommand(input, context);
    };
    PutGroupPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutGroupPolicyCommand(output, context);
    };
    return PutGroupPolicyCommand;
}($Command));
export { PutGroupPolicyCommand };
