import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutRolePermissionsBoundaryRequest } from "../models/models_0";
import { deserializeAws_queryPutRolePermissionsBoundaryCommand, serializeAws_queryPutRolePermissionsBoundaryCommand, } from "../protocols/Aws_query";
var PutRolePermissionsBoundaryCommand = (function (_super) {
    __extends(PutRolePermissionsBoundaryCommand, _super);
    function PutRolePermissionsBoundaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutRolePermissionsBoundaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "PutRolePermissionsBoundaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutRolePermissionsBoundaryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutRolePermissionsBoundaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutRolePermissionsBoundaryCommand(input, context);
    };
    PutRolePermissionsBoundaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutRolePermissionsBoundaryCommand(output, context);
    };
    return PutRolePermissionsBoundaryCommand;
}($Command));
export { PutRolePermissionsBoundaryCommand };
