import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutUserPermissionsBoundaryRequest } from "../models/models_0";
import { deserializeAws_queryPutUserPermissionsBoundaryCommand, serializeAws_queryPutUserPermissionsBoundaryCommand, } from "../protocols/Aws_query";
var PutUserPermissionsBoundaryCommand = (function (_super) {
    __extends(PutUserPermissionsBoundaryCommand, _super);
    function PutUserPermissionsBoundaryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutUserPermissionsBoundaryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "PutUserPermissionsBoundaryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutUserPermissionsBoundaryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutUserPermissionsBoundaryCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutUserPermissionsBoundaryCommand(input, context);
    };
    PutUserPermissionsBoundaryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutUserPermissionsBoundaryCommand(output, context);
    };
    return PutUserPermissionsBoundaryCommand;
}($Command));
export { PutUserPermissionsBoundaryCommand };
