import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutUserPolicyRequest } from "../models/models_0";
import { deserializeAws_queryPutUserPolicyCommand, serializeAws_queryPutUserPolicyCommand, } from "../protocols/Aws_query";
var PutUserPolicyCommand = (function (_super) {
    __extends(PutUserPolicyCommand, _super);
    function PutUserPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutUserPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "PutUserPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutUserPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutUserPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutUserPolicyCommand(input, context);
    };
    PutUserPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutUserPolicyCommand(output, context);
    };
    return PutUserPolicyCommand;
}($Command));
export { PutUserPolicyCommand };
