import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RemoveRoleFromInstanceProfileRequest } from "../models/models_0";
import { deserializeAws_queryRemoveRoleFromInstanceProfileCommand, serializeAws_queryRemoveRoleFromInstanceProfileCommand, } from "../protocols/Aws_query";
var RemoveRoleFromInstanceProfileCommand = (function (_super) {
    __extends(RemoveRoleFromInstanceProfileCommand, _super);
    function RemoveRoleFromInstanceProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RemoveRoleFromInstanceProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "RemoveRoleFromInstanceProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RemoveRoleFromInstanceProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RemoveRoleFromInstanceProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryRemoveRoleFromInstanceProfileCommand(input, context);
    };
    RemoveRoleFromInstanceProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryRemoveRoleFromInstanceProfileCommand(output, context);
    };
    return RemoveRoleFromInstanceProfileCommand;
}($Command));
export { RemoveRoleFromInstanceProfileCommand };
