import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ResyncMFADeviceRequest } from "../models/models_0";
import { deserializeAws_queryResyncMFADeviceCommand, serializeAws_queryResyncMFADeviceCommand, } from "../protocols/Aws_query";
var ResyncMFADeviceCommand = (function (_super) {
    __extends(ResyncMFADeviceCommand, _super);
    function ResyncMFADeviceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ResyncMFADeviceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "ResyncMFADeviceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ResyncMFADeviceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ResyncMFADeviceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryResyncMFADeviceCommand(input, context);
    };
    ResyncMFADeviceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryResyncMFADeviceCommand(output, context);
    };
    return ResyncMFADeviceCommand;
}($Command));
export { ResyncMFADeviceCommand };
