import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SetSecurityTokenServicePreferencesRequest } from "../models/models_0";
import { deserializeAws_querySetSecurityTokenServicePreferencesCommand, serializeAws_querySetSecurityTokenServicePreferencesCommand, } from "../protocols/Aws_query";
var SetSecurityTokenServicePreferencesCommand = (function (_super) {
    __extends(SetSecurityTokenServicePreferencesCommand, _super);
    function SetSecurityTokenServicePreferencesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SetSecurityTokenServicePreferencesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "SetSecurityTokenServicePreferencesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SetSecurityTokenServicePreferencesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SetSecurityTokenServicePreferencesCommand.prototype.serialize = function (input, context) {
        return serializeAws_querySetSecurityTokenServicePreferencesCommand(input, context);
    };
    SetSecurityTokenServicePreferencesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_querySetSecurityTokenServicePreferencesCommand(output, context);
    };
    return SetSecurityTokenServicePreferencesCommand;
}($Command));
export { SetSecurityTokenServicePreferencesCommand };
