import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SimulatePolicyResponse, SimulatePrincipalPolicyRequest } from "../models/models_0";
import { deserializeAws_querySimulatePrincipalPolicyCommand, serializeAws_querySimulatePrincipalPolicyCommand, } from "../protocols/Aws_query";
var SimulatePrincipalPolicyCommand = (function (_super) {
    __extends(SimulatePrincipalPolicyCommand, _super);
    function SimulatePrincipalPolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SimulatePrincipalPolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "SimulatePrincipalPolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SimulatePrincipalPolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: SimulatePolicyResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SimulatePrincipalPolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_querySimulatePrincipalPolicyCommand(input, context);
    };
    SimulatePrincipalPolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_querySimulatePrincipalPolicyCommand(output, context);
    };
    return SimulatePrincipalPolicyCommand;
}($Command));
export { SimulatePrincipalPolicyCommand };
