import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { TagInstanceProfileRequest } from "../models/models_0";
import { deserializeAws_queryTagInstanceProfileCommand, serializeAws_queryTagInstanceProfileCommand, } from "../protocols/Aws_query";
var TagInstanceProfileCommand = (function (_super) {
    __extends(TagInstanceProfileCommand, _super);
    function TagInstanceProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    TagInstanceProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "TagInstanceProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: TagInstanceProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    TagInstanceProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryTagInstanceProfileCommand(input, context);
    };
    TagInstanceProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryTagInstanceProfileCommand(output, context);
    };
    return TagInstanceProfileCommand;
}($Command));
export { TagInstanceProfileCommand };
