import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UntagMFADeviceRequest } from "../models/models_0";
import { deserializeAws_queryUntagMFADeviceCommand, serializeAws_queryUntagMFADeviceCommand, } from "../protocols/Aws_query";
var UntagMFADeviceCommand = (function (_super) {
    __extends(UntagMFADeviceCommand, _super);
    function UntagMFADeviceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UntagMFADeviceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UntagMFADeviceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UntagMFADeviceRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UntagMFADeviceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUntagMFADeviceCommand(input, context);
    };
    UntagMFADeviceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUntagMFADeviceCommand(output, context);
    };
    return UntagMFADeviceCommand;
}($Command));
export { UntagMFADeviceCommand };
