import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateAssumeRolePolicyRequest } from "../models/models_1";
import { deserializeAws_queryUpdateAssumeRolePolicyCommand, serializeAws_queryUpdateAssumeRolePolicyCommand, } from "../protocols/Aws_query";
var UpdateAssumeRolePolicyCommand = (function (_super) {
    __extends(UpdateAssumeRolePolicyCommand, _super);
    function UpdateAssumeRolePolicyCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateAssumeRolePolicyCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateAssumeRolePolicyCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateAssumeRolePolicyRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateAssumeRolePolicyCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateAssumeRolePolicyCommand(input, context);
    };
    UpdateAssumeRolePolicyCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateAssumeRolePolicyCommand(output, context);
    };
    return UpdateAssumeRolePolicyCommand;
}($Command));
export { UpdateAssumeRolePolicyCommand };
