import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateLoginProfileRequest } from "../models/models_1";
import { deserializeAws_queryUpdateLoginProfileCommand, serializeAws_queryUpdateLoginProfileCommand, } from "../protocols/Aws_query";
var UpdateLoginProfileCommand = (function (_super) {
    __extends(UpdateLoginProfileCommand, _super);
    function UpdateLoginProfileCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateLoginProfileCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateLoginProfileCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateLoginProfileRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateLoginProfileCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateLoginProfileCommand(input, context);
    };
    UpdateLoginProfileCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateLoginProfileCommand(output, context);
    };
    return UpdateLoginProfileCommand;
}($Command));
export { UpdateLoginProfileCommand };
