import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateOpenIDConnectProviderThumbprintRequest } from "../models/models_1";
import { deserializeAws_queryUpdateOpenIDConnectProviderThumbprintCommand, serializeAws_queryUpdateOpenIDConnectProviderThumbprintCommand, } from "../protocols/Aws_query";
var UpdateOpenIDConnectProviderThumbprintCommand = (function (_super) {
    __extends(UpdateOpenIDConnectProviderThumbprintCommand, _super);
    function UpdateOpenIDConnectProviderThumbprintCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateOpenIDConnectProviderThumbprintCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateOpenIDConnectProviderThumbprintCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateOpenIDConnectProviderThumbprintRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateOpenIDConnectProviderThumbprintCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateOpenIDConnectProviderThumbprintCommand(input, context);
    };
    UpdateOpenIDConnectProviderThumbprintCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateOpenIDConnectProviderThumbprintCommand(output, context);
    };
    return UpdateOpenIDConnectProviderThumbprintCommand;
}($Command));
export { UpdateOpenIDConnectProviderThumbprintCommand };
