import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateRoleDescriptionRequest, UpdateRoleDescriptionResponse } from "../models/models_1";
import { deserializeAws_queryUpdateRoleDescriptionCommand, serializeAws_queryUpdateRoleDescriptionCommand, } from "../protocols/Aws_query";
var UpdateRoleDescriptionCommand = (function (_super) {
    __extends(UpdateRoleDescriptionCommand, _super);
    function UpdateRoleDescriptionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateRoleDescriptionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateRoleDescriptionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateRoleDescriptionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateRoleDescriptionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateRoleDescriptionCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateRoleDescriptionCommand(input, context);
    };
    UpdateRoleDescriptionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateRoleDescriptionCommand(output, context);
    };
    return UpdateRoleDescriptionCommand;
}($Command));
export { UpdateRoleDescriptionCommand };
