import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateSAMLProviderRequest, UpdateSAMLProviderResponse } from "../models/models_1";
import { deserializeAws_queryUpdateSAMLProviderCommand, serializeAws_queryUpdateSAMLProviderCommand, } from "../protocols/Aws_query";
var UpdateSAMLProviderCommand = (function (_super) {
    __extends(UpdateSAMLProviderCommand, _super);
    function UpdateSAMLProviderCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateSAMLProviderCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateSAMLProviderCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateSAMLProviderRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateSAMLProviderResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateSAMLProviderCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateSAMLProviderCommand(input, context);
    };
    UpdateSAMLProviderCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateSAMLProviderCommand(output, context);
    };
    return UpdateSAMLProviderCommand;
}($Command));
export { UpdateSAMLProviderCommand };
