import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateServerCertificateRequest } from "../models/models_1";
import { deserializeAws_queryUpdateServerCertificateCommand, serializeAws_queryUpdateServerCertificateCommand, } from "../protocols/Aws_query";
var UpdateServerCertificateCommand = (function (_super) {
    __extends(UpdateServerCertificateCommand, _super);
    function UpdateServerCertificateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateServerCertificateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateServerCertificateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateServerCertificateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateServerCertificateCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateServerCertificateCommand(input, context);
    };
    UpdateServerCertificateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateServerCertificateCommand(output, context);
    };
    return UpdateServerCertificateCommand;
}($Command));
export { UpdateServerCertificateCommand };
