import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateSigningCertificateRequest } from "../models/models_1";
import { deserializeAws_queryUpdateSigningCertificateCommand, serializeAws_queryUpdateSigningCertificateCommand, } from "../protocols/Aws_query";
var UpdateSigningCertificateCommand = (function (_super) {
    __extends(UpdateSigningCertificateCommand, _super);
    function UpdateSigningCertificateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateSigningCertificateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UpdateSigningCertificateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateSigningCertificateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateSigningCertificateCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUpdateSigningCertificateCommand(input, context);
    };
    UpdateSigningCertificateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUpdateSigningCertificateCommand(output, context);
    };
    return UpdateSigningCertificateCommand;
}($Command));
export { UpdateSigningCertificateCommand };
