import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UploadServerCertificateRequest, UploadServerCertificateResponse } from "../models/models_1";
import { deserializeAws_queryUploadServerCertificateCommand, serializeAws_queryUploadServerCertificateCommand, } from "../protocols/Aws_query";
var UploadServerCertificateCommand = (function (_super) {
    __extends(UploadServerCertificateCommand, _super);
    function UploadServerCertificateCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UploadServerCertificateCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IAMClient";
        var commandName = "UploadServerCertificateCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UploadServerCertificateRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UploadServerCertificateResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UploadServerCertificateCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryUploadServerCertificateCommand(input, context);
    };
    UploadServerCertificateCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryUploadServerCertificateCommand(output, context);
    };
    return UploadServerCertificateCommand;
}($Command));
export { UploadServerCertificateCommand };
