import { RegionInfo } from "@aws-sdk/types";
import { GetHostnameTemplateOptions } from "./getHostnameTemplate";
import { GetResolvedPartitionOptions } from "./getResolvedPartition";
export declare type RegionHash = {
    [key: string]: Partial<Omit<RegionInfo, "partition" | "path">>;
};
export interface GetResolvedHostnameOptions extends GetHostnameTemplateOptions, GetResolvedPartitionOptions {
    /**
     * The hash of region with the information specific to that region.
     * The information can include hostname, signingService and signingRegion.
     */
    regionHash: RegionHash;
}
export declare const getResolvedHostname: (region: string, { signingService, regionHash, partitionHash }: GetResolvedHostnameOptions) => string;
