"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_base64_node_1 = require("@aws-sdk/util-base64-node");
const util_hex_encoding_1 = require("@aws-sdk/util-hex-encoding");
const _1 = require("./");
const hashVectors = require("hash-test-vectors");
describe("Md5", () => {
    let idx = 0;
    for (const { input, ...results } of hashVectors) {
        const expected = results["md5"];
        it(`should calculate a MD5 hash of ${expected} for test vector ${++idx}`, async () => {
            const hash = new _1.Md5();
            hash.update(util_base64_node_1.fromBase64(input));
            expect(util_hex_encoding_1.toHex(await hash.digest())).toBe(expected);
        });
    }
});
